if not XAudio then
  log("[SanicSpeedBoost] Error: SuperBLT not installed!")
  return
end

if not SanicSpeedBoost then
  _G.SanicSpeedBoost = {}
  
  blt.xaudio.setup()
  
  SanicSpeedBoost.buffer = XAudio.Buffer:new(ModPath .. "speed_boost.ogg")
end

if RequiredScript == "lib/units/beings/player/playermovement" then

  local lastplayed
  local on_morale_boost_original = PlayerMovement.on_morale_boost
  function PlayerMovement:on_morale_boost(...)
    if not lastplayed or lastplayed < Application:time() + 5 then
      lastplayed = Application:time()
      local src = XAudio.Source:new(SanicSpeedBoost.buffer)
      src:set_relative(true)
      src._gain = 1
    end
    return on_morale_boost_original(self, ...)
  end

end

if RequiredScript == "lib/units/beings/player/states/playerstandard" then

  local _get_intimidation_action_original = PlayerStandard._get_intimidation_action
  function PlayerStandard:_get_intimidation_action(prime_target, ...)
    local results = table.pack(_get_intimidation_action_original(self, prime_target, ...))
    if results[1] == "boost" and managers.groupai:state():all_player_criminals()[prime_target.unit:key()] then
      local src = XAudio.UnitSource:new(prime_target.unit, SanicSpeedBoost.buffer)
      src._gain = 2
    end
    return unpack(results)
  end

end